// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "BountyClass.h"
#include "SideBountyClass.generated.h"

DECLARE_DYNAMIC_MULTICAST_DELEGATE_OneParam(FCompletedSideBounty, int, SB_Index);

UCLASS()
class ENDLESSVENDETTA_API ASideBountyClass : public ABountyClass
{
	GENERATED_BODY()

	UPROPERTY(EditDefaultsOnly, Category = "Side Bounty")
	TMap<int, TSubclassOf<ACheckpointClass>> ReplacementCheckpoints;

protected:
	virtual void BeginPlay() override;

public:
	FCompletedSideBounty CompletedSideBounty;
	
	int ActiveSBC_Index;

	TMap<int, TSubclassOf<ACheckpointClass>> GetReplacementCheckpoints()
	{
		return ReplacementCheckpoints;
	}

	virtual void IncrementBountyCheckpoint() override;

	void DestroyCheckpoints();
};
