// Fill out your copyright notice in the Description page of Project Settings.


#include "VisionLink.h"

void AVisionLink::BeginPlay()
{
	Super::BeginPlay();
	SetActorTickEnabled(false);
	CooldownLength = CooldownTime;
	InUseDuration = GadgetMaxUptime;

	if (NumberOfPingPulses <= 0 ) NumberOfPingPulses = 1;
	TimeInbetweenPingPulses = GadgetMaxUptime / (float)NumberOfPingPulses;
}

void AVisionLink::Activate()
{
	if (GadgetCantBeUsed()) return;

	Super::Activate();

	NumOfPingPulsesLeftInThisCycle = NumberOfPingPulses;
	VisionLinkActivated();
	SendOutPingPulse();
}

void AVisionLink::FinishedUsing()
{
	VisionLinkRecharging();
	
	Super::FinishedUsing();
}

void AVisionLink::SendOutPingPulse()
{
	NumOfPingPulsesLeftInThisCycle--;
	UpdatePulsesRemaining(NumOfPingPulsesLeftInThisCycle);
	if (NumOfPingPulsesLeftInThisCycle < 0) return;

	// THIS IS WHERE I"LL PUT PING PULSE LOGIC
	UE_LOG(LogTemp, Warning, TEXT("Ping Pulse!"));
	GetWorld()->GetTimerManager().SetTimer(PulseHandle, this, &AVisionLink::SendOutPingPulse, TimeInbetweenPingPulses, false);
	PlayPingPulseAnim(TimeInbetweenPingPulses);
}



